/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.ui.deploymentservice.preference;

import org.eclipse.jface.preference.DirectoryFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Group;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.spagic3.ui.deploymentservice.Activator;
import org.spagic3.utils.SpagicUtilsActivator;
import org.spagic3.utils.preference.SpagicPreferenceConstants;

public class DeployServicePreferencePage extends FieldEditorPreferencePage implements
		IWorkbenchPreferencePage {

	// Refactoring: moved in the Spagic Preference Constants in org.spagic3.utils plugin
//	public static String P_DEPLOY_SERVICE_TARGET_DIR = "org.spagic3.ui.deploymentservice.preference.deploy.service.target.dir";
	
	private DirectoryFieldEditor targetDirEditor;
	
	public DeployServicePreferencePage() {
		super(GRID);
		// Refactoring: moved in the Spagic Preference Constants in org.spagic3.utils plugin
//		setPreferenceStore(
//				Activator.getDefault().getPreferenceStore());
		setPreferenceStore(SpagicUtilsActivator.getDefault().getPreferenceStore());
		setDescription("Spagic Deploy Service Preferences");
	}
	
	@Override
	protected void createFieldEditors() {
		Group serviceDeployPropertiesGroup = new Group(
				getFieldEditorParent(), 
				SWT.SHADOW_ETCHED_IN);
		
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		serviceDeployPropertiesGroup.setLayoutData(gd);
		serviceDeployPropertiesGroup.setText(" Service Deployment Section ");

		targetDirEditor = new DirectoryFieldEditor(
				SpagicPreferenceConstants.P_DEPLOY_SERVICE_TARGET_DIR, 
				"Target Directory", 
				serviceDeployPropertiesGroup);
		addField(targetDirEditor);
	}

	public void init(IWorkbench workbench) {}

}
