package org.spagic3.utils.filter;

import java.util.Iterator;
import java.util.List;

import org.eclipse.core.internal.resources.File;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.stp.bpmn.BpmnDiagram;
import org.eclipse.stp.bpmn.Pool;
import org.eclipse.stp.im.constants.ImConstants;
import org.eclipse.ui.IActionFilter;

public class MenuFilter implements IActionFilter{
	
	private static MenuFilter INSTANCE = new MenuFilter();

	private MenuFilter() {}

	public boolean testAttribute(Object obj, String name, String value) {
		if(name.equalsIgnoreCase("technology")){
			if(obj instanceof File){
				File bpmn = (File)obj;
				ResourceSet resourceSetBpmn = new ResourceSetImpl();
				
				URI uri = URI.createPlatformResourceURI(bpmn.getFullPath().toString(),true);
			
				Resource resourceBpmn = resourceSetBpmn.getResource(uri, true);
				BpmnDiagram bpmnDiagram= (BpmnDiagram)resourceBpmn.getContents().get(0);
				List<Pool> thePools = bpmnDiagram.getPools();
				for (Iterator iterator = thePools.iterator(); iterator.hasNext();) {
					Pool pool = (Pool) iterator.next();
					if (pool instanceof Pool) {
						EAnnotation technologyAnnotation = pool.getEAnnotation(ImConstants.TECHNOLOGY_ANNOTATION);
						if (technologyAnnotation != null){
							String runtimeId  = technologyAnnotation.getDetails().get(ImConstants.IM_POOL_RUNTIME_ID);
							String runtimeName  = technologyAnnotation.getDetails().get(ImConstants.TECHNOLOGY_NAME);
							String result = (runtimeName != null ? runtimeName : runtimeId);
							if(result.equalsIgnoreCase(value))
								return true;
							else
								return false;
						}
					}
				}
					
			}				
		}
		return false;
	}
	
	public static MenuFilter getInstance() {
		return INSTANCE;
	}


}
